<?php
/*
Plugin Name: Better tag cloud widget
Plugin URI: http://www.nkuttler.de/nktagcloud/
Author: Nicolas Kuttler
Author URI: http://www.nkuttler.de/
Description: Better tag cloud
Version: 0.6.2
*/

/* Prints a <select> and the listed <option>s
	form_select( str, str, array ) */
function form_select($title, $name, $choice, $br = false) {
	print $title; ?>
	<select name="<?php echo $name; ?>"><?php
		$select = get_option($name);
		foreach ($choice as $unit) {
			if ( $unit == $select ) {
				echo "<option selected>$unit</option>\n";
			}
			else {
				echo "<option>$unit</option>\n";
			}
		} ?>
	</select>
	<?php
		if ($br) {
			echo '<br>';
		}
	?>
	<?php
}

function nktagcloud_init() {
	register_sidebar_widget('Better tag cloud', 'widget_nktagcloud');
	register_widget_control('Better tag cloud', 'nktagcloud_control');
}

add_action('plugins_loaded', 'nktagcloud_init');
if (!(get_option('nktagcloud_homelink') === 'Yes')) {
	add_action('wp_footer', 'nktagcloud_footer');
}
if (
	!(get_option('nktagcloud_rmcss') === 'Yes')
	&& (get_option('nktagcloud_format') === 'list' )
) {
	add_action('wp_head', 'nktagcloud_head');      	
}

function widget_nktagcloud($args) {
	extract($args);
	echo $before_widget;
	echo $before_title;
	echo get_option('nktagcloud_title');
	echo $after_title;
	$smallest= get_option('nktagcloud_smallest');
	$largest= get_option('nktagcloud_largest');
	$unit= get_option('nktagcloud_unit');
	$number= get_option('nktagcloud_number');
	$format= get_option('nktagcloud_format');
	$order= get_option('nktagcloud_order');
	$orderby= get_option('nktagcloud_orderby');
	$exclude= get_option('nktagcloud_exclude');
	$include= get_option('nktagcloud_include');
	if (get_option('nktagcloud_replace') == 'Yes') {
		add_filter('wp_tag_cloud', 'nkreplace');
	}
    nk_wp_tag_cloud("largest=$largest&smallest=$smallest&unit=$unit&number=$number&format=$format&order=$order&orderby=$orderby&exclude=$exclude&include=$include");
	echo $after_widget;
}

// Force multi-word tags on one line with &nbsp;s
function nkreplace($tag = '') {
	$tag = preg_replace('#(<a.+?>.+?) (.+</a>)#', '$1&nbsp;$2', $tag);
	return $tag;
}

// Install hook
register_activation_hook(__FILE__,'nktagcloud_install');
function nktagcloud_install() {
	update_option('nktagcloud_title', 'Tags');
	update_option('nktagcloud_smallest', '8');
	update_option('nktagcloud_largest', '22');
	update_option('nktagcloud_unit', 'pt');
	update_option('nktagcloud_number', '0');
	update_option('nktagcloud_format', 'list');
	update_option('nktagcloud_order', 'ASC');
	update_option('nktagcloud_orderby', 'name');
	update_option('nktagcloud_homelink', 'No');
	update_option('nktagcloud_rmcss', 'No');
	update_option('nktagcloud_replace', 'No');
	update_option('nktagcloud_inject_count', 'No');
	update_option('nktagcloud_decor', 'notouch');
	update_option('nktagcloud_exclude', '');
	update_option('nktagcloud_include', '');
}

function nktagcloud_control() { ?>
There were too many options, so I had to move the configuration
to a <a href="<?php bloginfo('url') ?>/wp-admin/options-general.php?page=nktagcloud">settings page</a>.
<?php
}

// Hook for adding admin menus
add_action('admin_menu', 'nktagcloud_add_pages');

function nktagcloud_add_pages() {
    add_options_page('Better Tag Cloud', 'Better Tag Cloud', 10, 'nktagcloud', 'nktagcloud_options_page');
	function nktagcloud_options_page() {
		if ( $_POST['nktagcloud_title'] ) {
			update_option('nktagcloud_title', $_POST['nktagcloud_title']);
			update_option('nktagcloud_smallest', $_POST['nktagcloud_smallest']);
			update_option('nktagcloud_largest', $_POST['nktagcloud_largest']);
			update_option('nktagcloud_unit', $_POST['nktagcloud_unit']);
			update_option('nktagcloud_number', intval($_POST['nktagcloud_number']));
			update_option('nktagcloud_format', $_POST['nktagcloud_format']);
			update_option('nktagcloud_order', $_POST['nktagcloud_order']);
			update_option('nktagcloud_orderby', $_POST['nktagcloud_orderby']);
			update_option('nktagcloud_homelink', $_POST['nktagcloud_homelink']);
			update_option('nktagcloud_rmcss', $_POST['nktagcloud_rmcss']);
			update_option('nktagcloud_replace', $_POST['nktagcloud_replace']);
			update_option('nktagcloud_inject_count', $_POST['nktagcloud_inject_count']);
			update_option('nktagcloud_decor', $_POST['nktagcloud_decor']);
			update_option('nktagcloud_exclude', $_POST['nktagcloud_exclude']);
			update_option('nktagcloud_include', $_POST['nktagcloud_include']);
		}
		?>
<div class="wrap" style="margin: 2mm; max-width: 100ex;">
	<h2>Better Tag Cloud</h2>
	<p> 
	The default tag cloud widget that comes with wordpress is very simple. This widget makes the options for wp_tag_cloud() and more available to the a new tag cloud widget. 
	<br />
	Visit the <a href="http://www.nkuttler.de/nkthemeswitch/">plugin's home page</a> to leave comments or <a href="http://www.wordpress.org/extend/plugins/nkthemeswitch/">rate this widget</a>.
	</p>
	
	<h3>My other plugins</h3>
	<p>
	<a href="http://www.nkuttler.de/nkthemeswitch/">Theme switch</a>:
	I like to tweak my main theme that I use on a varity of blogs. If you have ever done this you know how annoying it can be to break things for visitors of your blog. This plugin allows you to use a different theme than the one used for your visitors when you are logged in.
	<br/>
	<a href="http://www.rhymebox.de/blog/rhymebox-widget/">Rhyming widget</a>:
	I wrote a little online rhyming dictionary. This is a widget to search it directly from one of your sidebars.
	<br/>
	<a href="http://www.nkuttler.de/nksnow/">Snow and more</a>:
	This one lets you see snowflakes (or other, custom images) fall down your blog.
	<br/>
	<a href="http://www.nkuttler.de/nkfireworks/">Fireworks</a>:
	The name says it all, see fireworks on your blog!
	</p>
	
	<h2>Widget Configuration</h2>
	<p>Please see <a href="http://codex.wordpress.org/Template_Tags/wp_tag_cloud" target="_blank">the wp_tag_cloud() page</a> for a detailed description of the options.</p>
	<form action="" method="post">
		Title
		<?php
			$select = get_option('nktagcloud_title'); 
		?>
		<input name="nktagcloud_title" type="text" size="15" value="<?php echo $select; ?>" />
		<br />
		Smallest font size
		<input name="nktagcloud_smallest" size="4" type="text" value="<?php echo get_option('nktagcloud_smallest'); ?>"/>
		Largest font size
		<input name="nktagcloud_largest"  size="4" type="text" value="<?php echo get_option('nktagcloud_largest'); ?>" />
		<?php
			/*
			form_select('Smallest font size', 'nktagcloud_smallest', range(6,40) );
			form_select('Largest font size', 'nktagcloud_largest', range(6,40) );
			*/
			form_select('Unit', 'nktagcloud_unit', array('pt', 'px', '%', 'em', 'ex', 'mm') );
		?>
		<br />
		Number of tags to show
		<?php
			$select = get_option('nktagcloud_number'); 
		?>
		<input name="nktagcloud_number" type="text" size="3" value="<?php echo $select; ?>" />
		<br />
		<?php
			form_select('Format', 'nktagcloud_format', array('flat', 'list') );
			form_select('Order', 'nktagcloud_order', array('ASC', 'DESC', 'RAND' ) );
			form_select('Orderby', 'nktagcloud_orderby', array('name', 'count', 'both' ) );
		?>
		<p>
		The 'both' option of <tt>Orderby</tt> will sort by post count first
		and then by name. It doesn't exist in the default tag cloud
		and will ignore the <tt>Order</tt> option.
		</p>
		<?php
			form_select('Add post count to tags?',
			'nktagcloud_inject_count', array('No', 'Yes'), true );
			form_select('Force tags with multiple words on one line?',
'nktagcloud_replace', array('No', 'Yes') );
		?>
		<br />
		<input type="submit" class="button-primary" value="Save changes" />
		<h3>CSS settings</h2>
		<p>
		<?php
			form_select('Remove CSS for list format that displays the tags inline?', 'nktagcloud_rmcss', array('No', 'Yes'), true );
form_select('Tag link decoration', 'nktagcloud_decor', array('underline', 'none', 'don\'t touch' ), true );
		?>
		<p>This may allow you to underline the tag links or to remove the underlining. If your theme already defines a style for links this may not work, please don't ask for support if it doesn't.
		</p>
		<?php
			form_select('Remove link to widget website?', 'nktagcloud_homelink', array('No', 'Yes') );
		?>
		<br />
		<input type="submit" class="button-primary" value="Save changes" />
		</p>
		<h3>Exclude/Include tags</h2>
		<p>
			Exclude tags. Comma separated list of tags (term_id) to exclude. For example, 'exclude=5,27' means tags that have the term_id 5 or 27 will NOT be displayed. See <a href="http://codex.wordpress.org/Template_Tags/wp_tag_cloud">Template Tags/wp tag cloud</a>.
			<br />
			<input name="nktagcloud_exclude" type="text" size="40" value="<?php echo get_option('nktagcloud_exclude'); ?>" />
		</p>
		<p>
			Include tags. Format as above.
			<br />
			<input name="nktagcloud_include" type="text" size="40" value="<?php echo get_option('nktagcloud_include'); ?>" />
			<br />
			<input type="submit" class="button-primary" value="Save changes" />
	</form>
	</div> <?php
	}
}

function nktagcloud_head($underline = 'foobar' ) { ?>
<style type="text/css">
li#better-tag-cloud ul.wp-tag-cloud li,
li#better-tag-cloud ul.wp-tag-cloud li a {
	display:	inline;
	<?php
		if ($underline == 'none') {
			echo "text-decoration: none;";
		}
		elseif ($underline == 'underline') {
			echo "text-decoration: underline;";
		}
	?>
}
</style>
<?php
}

function nktagcloud_footer() { ?>
<a href="http://www.nkuttler.de/nktagcloud/">Tag cloud widget</a> powered by <a href="http://www.nkuttler.de/nktagcloud/">nktagcloud</a>
<?php
}

/* This was copied from the wordpress source and modified, see 
 * wp-includes/category-template.php
*/

/**
 * Display tag cloud.
 *
 * The text size is set by the 'smallest' and 'largest' arguments, which will
 * use the 'unit' argument value for the CSS text size unit. The 'format'
 * argument can be 'flat' (default), 'list', or 'array'. The flat value for the
 * 'format' argument will separate tags with spaces. The list value for the
 * 'format' argument will format the tags in a UL HTML list. The array value for
 * the 'format' argument will return in PHP array type format.
 *
 * The 'orderby' argument will accept 'name' or 'count' and defaults to 'name'.
 * The 'order' is the direction to sort, defaults to 'ASC' and can be 'DESC'.
 *
 * The 'number' argument is how many tags to return. By default, the limit will
 * be to return the top 45 tags in the tag cloud list.
 *
 * The 'topic_count_text_callback' argument is a function, which, given the count
 * of the posts  with that tag, returns a text for the tooltip of the tag link.
 *
 * The 'exclude' and 'include' arguments are used for the {@link get_tags()}
 * function. Only one should be used, because only one will be used and the
 * other ignored, if they are both set.
 *
 * @since 2.3.0
 *
 * @param array|string $args Optional. Override default arguments.
 * @return array Generated tag cloud, only if no failures and 'array' is set for the 'format' argument.
 */
function nk_wp_tag_cloud( $args = '' ) {
    $defaults = array(
        'smallest' => 8, 'largest' => 22, 'unit' => 'pt', 'number' => 45,
        'format' => 'flat', 'orderby' => 'name', 'order' => 'ASC',
        'exclude' => '', 'include' => '', 'link' => 'view'
    );
    $args = wp_parse_args( $args, $defaults );

    $tags = get_tags( array_merge( $args, array( 'orderby' => 'count', 'order' => 'DESC' ) ) ); // Always query top tags

    if ( empty( $tags ) )
        return;

    foreach ( $tags as $key => $tag ) {
        if ( 'edit' == $args['link'] )
            $link = get_edit_tag_link( $tag->term_id );
        else
            $link = get_tag_link( $tag->term_id );
        if ( is_wp_error( $link ) )
            return false;

        $tags[ $key ]->link = $link;
        $tags[ $key ]->id = $tag->term_id;
    }
    
    $return = nk_wp_generate_tag_cloud( $tags, $args ); // Here's where those top tags get sorted according to $args

    $return = apply_filters( 'wp_tag_cloud', $return, $args );

    if ( 'array' == $args['format'] )
        return $return;

    echo $return;
}

/**
 * Generates a tag cloud (heatmap) from provided data.
 *
 * The text size is set by the 'smallest' and 'largest' arguments, which will
 * use the 'unit' argument value for the CSS text size unit. The 'format'
 * argument can be 'flat' (default), 'list', or 'array'. The flat value for the
 * 'format' argument will separate tags with spaces. The list value for the
 * 'format' argument will format the tags in a UL HTML list. The array value for
 * the 'format' argument will return in PHP array type format.
 *
 * The 'orderby' argument will accept 'name' or 'count' and defaults to 'name'.
 * The 'order' is the direction to sort, defaults to 'ASC' and can be 'DESC' or
 * 'RAND'.
 *
 * The 'number' argument is how many tags to return. By default, the limit will
 * be to return the entire tag cloud list.
 *
 * The 'topic_count_text_callback' argument is a function, which given the count
 * of the posts  with that tag returns a text for the tooltip of the tag link.
 *
 * @todo Complete functionality.
 * @since 2.3.0
 *
 * @param array $tags List of tags.
 * @param string|array $args Optional, override default arguments.
 * @return string
 */
function nk_wp_generate_tag_cloud( $tags, $args = '' ) {
	global $wp_rewrite;
	$defaults = array(
		'smallest' => 8, 'largest' => 22, 'unit' => 'pt', 'number' => 0,
		'format' => 'flat', 'orderby' => 'name', 'order' => 'ASC',
		'topic_count_text_callback' => 'default_topic_count_text',
	);

	if ( !isset( $args['topic_count_text_callback'] ) && isset( $args['single_text'] ) && isset( $args['multiple_text'] ) ) {
		$body = 'return sprintf (
			__ngettext('.var_export($args['single_text'], true).', '.var_export($args['multiple_text'], true).', $count),
			number_format_i18n( $count ));';
		$args['topic_count_text_callback'] = create_function('$count', $body);
	}

	$args = wp_parse_args( $args, $defaults );

	extract( $args );

	if ( empty( $tags ) )
		return;

	// SQL cannot save you; this is a second (potentially different) sort on a subset of data.
	if ( 'name' == $orderby )
		uasort( $tags, create_function('$a, $b', 'return strnatcasecmp($a->name, $b->name);') );
	else
		uasort( $tags, create_function('$a, $b', 'return ($a->count > $b->count);') );

	if ( 'DESC' == $order )
		$tags = array_reverse( $tags, true );
	elseif ( 'RAND' == $order ) {
		$keys = array_rand( $tags, count( $tags ) );
		foreach ( $keys as $key )
			$temp[$key] = $tags[$key];
		$tags = $temp;
		unset( $temp );
	}

	/* nkuttler: support sorting by two criteria */
	if (get_option('nktagcloud_order') == 'both') {
		$orderby = 'both';
	}
	if ('both' == $orderby) {
		function compare_both($a, $b) {
			$retval = strnatcmp($b->count, $a->count);
			if(!$retval) return strnatcmp($a->name, $b->name);
			return $retval;
		} 
		usort($tags, 'compare_both');
	}
	/* end changes */

	if ( $number > 0 )
		$tags = array_slice($tags, 0, $number);

	$counts = array();
	foreach ( (array) $tags as $key => $tag )
		$counts[ $key ] = $tag->count;

	$min_count = min( $counts );
	$spread = max( $counts ) - $min_count;
	if ( $spread <= 0 )
		$spread = 1;
	$font_spread = $largest - $smallest;
	if ( $font_spread < 0 )
		$font_spread = 1;
	$font_step = $font_spread / $spread;

	$a = array();

	$rel = ( is_object( $wp_rewrite ) && $wp_rewrite->using_permalinks() ) ? ' rel="tag"' : '';

	/* added and modified nkuttler */
	function nk_add_counter($tag = NULL) {
		if (get_option('nktagcloud_inject_count') == 'Yes') {
			$inject = '&nbsp;(' . $tag->count . ')';
			return $inject;
		}
	}
	foreach ( $tags as $key => $tag ) {
		$count = $counts[ $key ];
		$tag_link = '#' != $tag->link ? clean_url( $tag->link ) : '#';
		$tag_id = isset($tags[ $key ]->id) ? $tags[ $key ]->id : $key;
		$tag_name = $tags[ $key ]->name;
		$a[] = "<a href='$tag_link' class='tag-link-$tag_id' title='" . attribute_escape( $topic_count_text_callback( $count ) ) . "'$rel style='font-size: " .
			( $smallest + ( ( $count - $min_count ) * $font_step ) )
			. "$unit;'>$tag_name". nk_add_counter($tag) ."</a>";
	}
	/* end changes */

	switch ( $format ) :
	case 'array' :
		$return =& $a;
		break;
	case 'list' :
		$return = "<ul class='wp-tag-cloud'>\n\t<li>";
		$return .= join( "</li>\n\t<li>", $a );
		$return .= "</li>\n</ul>\n";
		break;
	default :
		$return = join( "\n", $a );
		break;
	endswitch;

	return apply_filters( 'wp_generate_tag_cloud', $return, $tags, $args );
}

?>
